'use strict'
function isInViewport(element)  {
  const rect = element.getBoundingClientRect();
  return (
      rect.top >= 0 &&
      rect.left >= 0 &&
      rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
      rect.right <= (window.innerWidth || document.documentElement.clientWidth)
  );
}

function preloadImage(url){
    var img=new Image();
    img.src=url;
}

function preloadImages(urls) {
  if(checkEmpty(urls, true)){
    urls.forEach(function(url){
      if(checkEmpty(url)){
        preloadImage(url);
      }
    })
  }
};

const getQueryVariable = (queryString, variable) => {
  var query = queryString.substring(1);
  var vars = query.split('&');
  for (var i = 0; i < vars.length; i++) {
    var pair = vars[i].split('=');
    if (pair[0] == variable) {
      return pair[1];
    }
  }
  return false;
};
const checkEmpty = (value, isCheckLength = false) => {
  let returnVal = false;
  if (value && value !== undefined && value !== null && value !== '') {
    if (isCheckLength) {
      if (value.length > 0) {
        returnVal = true;
      }
    } else {
      returnVal = true;
    }
  }
  return returnVal;
};

const preloadElementInViewPort = (elenemt, imageURLS) =>{
  if(elenemt){
    if(checkEmpty(imageURLS, true)){
      document.addEventListener('scroll', function () {
        if(isInViewport(elenemt)){
          preloadImages(imageURLS);
        }
      });
    }
  }
}

document.addEventListener("DOMContentLoaded", function() {
    var preLoadImages = [].slice.call(document.querySelectorAll(".preload-images"));
    if ("IntersectionObserver" in window) {
      let preloadImageObserver = new IntersectionObserver(function(elements, observer) {
        elements.forEach(function(element) {
          if (element.isIntersecting) {
            const targetElement = element.target;
            const imageURLs = targetElement.dataset.srcset;
            preloadImages(imageURLs.split(','));
            targetElement.classList.remove("preload-images");
            preloadImageObserver.unobserve(targetElement);
          }
        });
      });
  
      preLoadImages.forEach(function(lazyImage) {
        preloadImageObserver.observe(lazyImage);
      });
    } else {
      // Possibly fall back to event handlers here
    }
  });
  
exports.getQueryVariable = getQueryVariable;
exports.checkEmpty = checkEmpty;
exports.preloadElementInViewPort = preloadElementInViewPort;